Bug 4656 - Possible Bug in Disk Druid
Possible Bug in Disk Druid
Product: Red Hat Linux
Classification: Retired
Component: util-linux (Show other bugs)
i386 Linux
low Severity medium
: ---
: ---
Assigned To: Brock Organ
Depends On:
  Show dependency treegraph
Reported: 1999-08-22 22:04 EDT by dickdelp
Modified: 2008-05-01 11:37 EDT (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2000-06-28 10:44:06 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description dickdelp 1999-08-22 22:04:42 EDT
Possible Bug in Disk Druid

Earlier today, I completed a new installation of Linux (Red
Hat Distribution 6.0.  It was apparently successful.  Before
beginning the installation, I deleted two previous
partitions, one at the end of the Extended partition and one
outside the Extended partition, immediately following it.
This left two contiguous free space areas, one inside and
one outside the extended partition.

Disk Druid was used for repartitioning.  It appeared to
recognize that the two free space areas were contiguous, and
treated them as one, at which I was pleasantly surprised.
Reserving 60 MB for a swap file, I assigned all of the free
space to Linux.  I expected that Disk Druid would resize the
extended partition as needed.

LILO was installed into the MBR, dual-booting Linux and
Windows 95.  Booting into both was successful.  Both appear
to work as expected.

I then used Partition Magic to examine the partitioning
setup.  It ran, but rather than presenting its usual
information, displayed "Partition Table Error #113 found."

Its help system was fully operational; Error #113 expands as
follows, omitting several passages:

"Partitions overlap. The hard disk partition table contains
erroneous values....

"This error is often the result of an OS/2 FDISK bug.  If
free space exists within the extended partition ..., OS/2's
FDISK program allows a primary partition to be created that
overlaps the extended partition....

"If a primary partition overlaps the end of the extended
partition, but does not overlap any logical partitions
within the extended partition, the problem can be remedied
by patching the partition table.  ONLY QUALIFIED INDIVIDUALS

Now OS/2 has never been used on this machine.

Using the fdisk program furnished with Windows 95, I
examined the partition situation.  It gave the total size of
the extended partition as 250 MB, with logical drive D: as
occupying 124 MB, (50% of it).  It also stated that the sum
of the four partitions (C:, extended, Linux, and Linux swap)
was 126 MB more than it reported as the total capacity of
the disk.  Notice that this is exactly the amount by which
the reported size of the extended partition exceeds that of
what is supposed to be its only contents (250 - 124).

I then used the fdisk supplied with Red Hat's distribution
of Linux 6.0 to reexamine the situation.  Its report
(command p) follows:

Disk /dev/hda: 64 heads, 63 sectors, 699 cylinders
Units = cylinders of 4032 * 512 bytes

   Device Boot Start End Blocks  Id System
/dev/hda1   *      1 257 518080+  b Win95 FAT32
/dev/hda2        258 384 256032   5 Extended
/dev/hda3        321 669 703584  83 Linux
/dev/hda4        670 699 60480   82 Linux Swap
/dev/hda5        258 320 126976+  6 FAT 16

The Linux fdisk is reporting that hda3, the Linux partition,
starts at cylinder 321, right after the end of logical
partition hda5, in spite of the fact that hda2, the extended
partition, is also claiming space up to and including
cylinder 384.  Cylinders 321 through 384 are being reported
as part of both hda2 and hda3.  These 64 cylinders agree in
capacity with the extra 126 MB reported by the Windows 95

It appears that the symptom matches that described by
Powerquest (manufacturers of Partition Magic) as an OS/2
FDISK bug.  Since I used Disk Druid at a time when the
extended partition contained free space  exactly the
circumstance reported to elicit the OS/2 bug -- it would
appear that Disk Druid has a similar bug.

I will not attempt to make any partitioning adjustments
until I fully grasp the situation.  But I suspect that both
Windows 95 and Linux are safe.

Any thoughts?

Dick Delp
Comment 1 Jay Turner 2000-04-17 12:52:59 EDT
This should certainly get put on a list for a test case.
Comment 2 Michael Fulbright 2000-06-22 12:34:04 EDT
Passed to test lab to integrate into testing procedure.
Comment 3 Brock Organ 2000-06-28 10:44:05 EDT
Thank you for your report!

This should be resolved in the current release (6.2) ... I was unable to create
the overlapping partition problem you described using both fdisk and ddruid in
the installer ... using fdisk, trying to overlap parititions failed with a
"value out of range", while setting up partitions in disk druid similar to how
you did, the 6.2 ddruid put both the swap & / partitions completely within the
extended partition, with the / partition using all available space within the
extended partition ...

Disk /dev/hda: 255 heads, 63 sectors, 1650 cylinders                            
Units = cylinders of 16065 * 512
Device Boot    Start       End    Blocks   Id  System                           
/dev/hda1   *         1       257   2064321    b  Win95 FAT32                   
/dev/hda2           258       384   1020127+   5  Extended                      
/dev/hda5           258       319    497983+   6  FAT16                         
/dev/hda6           320       377    465853+  83  Linux                         
/dev/hda7           378       384     56196   82  Linux

Note You need to log in before you can comment on or make changes to this bug.